﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using X3g.Plugin;

namespace SamplePlugin.SceneExplorer
{
    class OverlayBoundingBox
    {
        public OverlayBoundingBox(GeBoundingBox3d bounds, GeMatrix transform)
        {
            mLines = new List<OverlayPolyline3d>();
            mLines.Add(new OverlayPolyline3d(new GeVec3d[]{
                new GeVec3d(bounds.Min.x, bounds.Min.y, bounds.Min.z),
                new GeVec3d(bounds.Max.x, bounds.Min.y, bounds.Min.z),
                new GeVec3d(bounds.Max.x, bounds.Max.y, bounds.Min.z),
                new GeVec3d(bounds.Min.x, bounds.Max.y, bounds.Min.z),
                new GeVec3d(bounds.Min.x, bounds.Min.y, bounds.Min.z)
            }));
            mLines.Add(new OverlayPolyline3d(new GeVec3d[]{
                new GeVec3d(bounds.Min.x, bounds.Min.y, bounds.Max.z),
                new GeVec3d(bounds.Max.x, bounds.Min.y, bounds.Max.z),
                new GeVec3d(bounds.Max.x, bounds.Max.y, bounds.Max.z),
                new GeVec3d(bounds.Min.x, bounds.Max.y, bounds.Max.z),
                new GeVec3d(bounds.Min.x, bounds.Min.y, bounds.Max.z)
            }));
            mLines.Add(new OverlayPolyline3d(new GeVec3d[]{
                new GeVec3d(bounds.Min.x, bounds.Min.y, bounds.Min.z),
                new GeVec3d(bounds.Min.x, bounds.Min.y, bounds.Max.z),
            }));
            mLines.Add(new OverlayPolyline3d(new GeVec3d[]{
                new GeVec3d(bounds.Max.x, bounds.Min.y, bounds.Min.z),
                new GeVec3d(bounds.Max.x, bounds.Min.y, bounds.Max.z),
            }));
            mLines.Add(new OverlayPolyline3d(new GeVec3d[]{
                new GeVec3d(bounds.Max.x, bounds.Max.y, bounds.Min.z),
                new GeVec3d(bounds.Max.x, bounds.Max.y, bounds.Max.z),
            }));
            mLines.Add(new OverlayPolyline3d(new GeVec3d[]{
                new GeVec3d(bounds.Min.x, bounds.Max.y, bounds.Min.z),
                new GeVec3d(bounds.Min.x, bounds.Max.y, bounds.Max.z),
            }));

            foreach (var line in mLines)
            {
                line.Color = System.Drawing.Color.Red;
                line.LineWidth = 2;
                line.Transform = transform;
            }
        }

        public void Dispose()
        {
            foreach (var line in mLines)
                line.Dispose();
        }

        private List<OverlayPolyline3d> mLines;
    }
}
