set workingDir=%cd%

@echo off
call set_languages_var.bat
echo Will parse:
for %%i in (%LANGIDCODES%) do (
for /f "tokens=1,2,3 delims=. " %%a in ("%%i") do (
echo.File: %%a
echo.Lang: %%b
echo.Page: %%c
echo.
))

set PluginName=SamplePlugin
set PluginDir=%workingDir%"\..\..\Plugin Binaries\%PluginName%"

rem msgfmt needs to find c# compiler (csc.exe)
set PATH="c:\Program Files (x86)\MSBuild\14.0\Bin\amd64\";%PATH%
REM xslt processor needed for example "https://www.nuget.org/packages/Saxon-HE/"
echo converting ui file to xliff
3rd\saxon\tools\Transform.exe -s:"..\res\%PluginName%.ui" -xsl:UI2XLIFF.xslt -o:xliff.xlf
echo converting xliff to po
3rd\saxon\tools\Transform.exe -s:xliff.xlf -xsl:XLIFF2PO.xslt -o:locales\%PluginName%_ui.po
del xliff.xlf
REM GNU gettext needed
echo remove doubles
3rd\gettext\bin\msguniq --use-first -o "locales\%PluginName%_ui_unique.po" "locales\%PluginName%_ui.po"

echo Getting files from %PluginName%.csproj ...
cd ..
translation\3rd\FilelistFromVCProj %PluginName%.csproj files.txt

echo Parsing files...
translation\3rd\gettext\bin\xgettext -f files.txt -k -kI18N._ --from-code=UTF-8 -LC# --indent --add-location --add-comments --omit-header -o "translation\locales\%PluginName%.pot"

echo Combine ui and code po
translation\3rd\gettext\bin\msgcat --use-first --to-code=utf-8 -o "translation\locales\%PluginName%.pot" "translation\locales\%PluginName%_ui_unique.po" "translation\locales\%PluginName%.pot"
del "translation\locales\%PluginName%_ui_unique.po"

cd translation
for %%i in (%LANGIDCODES%) do (
for /f "tokens=1,2,3 delims=. " %%a in ("%%i") do (

IF NOT EXIST "locales\%%a.po" "3rd\gettext\bin\msginit" -l %%a_%%b -o "locales\%%a.po" -i "locales\%PluginName%.pot"

echo Merging %%b
call 3rd\gettext\bin\msgmerge --no-wrap -q -o "locales\%%a.po" "locales\%%a.po" "locales\%PluginName%.pot"
))

call cd "locales"

for %%i in (%LANGIDCODES%) do (
for /f "tokens=1,2,3 delims=. " %%a in ("%%i") do (

call echo Generating %%b

IF EXIST temp.po del temp.po
IF EXIST temp_cp.po del temp_cp.po

rem Remove fuzzy entries - emsgfmt accept these as translated!
call ..\3rd\gettext\bin\msgattrib --no-fuzzy -o temp.po %%a.po
echo Resource %%b.mo
call ..\3rd\gettext\bin\msgfmt -o ..\..\res\%%b.mo --strict temp.po
IF EXIST temp.po del temp.po
))
cd ..



pause